/*****************************************************************************

  Licensed to Accellera Systems Initiative Inc. (Accellera) under one or
  more contributor license agreements.  See the NOTICE file distributed
  with this work for additional information regarding copyright ownership.
  Accellera licenses this file to you under the Apache License, Version 2.0
  (the "License"); you may not use this file except in compliance with the
  License.  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
  implied.  See the License for the specific language governing
  permissions and limitations under the License.

 *****************************************************************************/

// test kind() function, constructor arguments, and default values of sca_eln::sca_vsource

#include <systemc-ams>
#include "test_utilities.h"

int sc_main( int, char*[] )
{
  TEST_LABEL_START;

  sca_eln::sca_vsource i_vsource("i_vsource");

  std::cout << "i_vsource.kind(): " << i_vsource.kind() << std::endl;

  std::cout << "i_vsource.p.kind(): " << i_vsource.p.kind() << std::endl;
  std::cout << "i_vsource.p.name(): " << i_vsource.p.name() << std::endl;

  std::cout << "i_vsource.n.kind(): " << i_vsource.n.kind() << std::endl;
  std::cout << "i_vsource.n.name(): " << i_vsource.n.name() << std::endl;

  std::cout << "i_vsource.init_value.kind(): " << i_vsource.init_value.kind() << std::endl;
  std::cout << "i_vsource.init_value.name(): " << i_vsource.init_value.name() << std::endl;
  std::cout << "default value of init_value: " << i_vsource.init_value << std::endl;

  std::cout << "i_vsource.offset.kind(): " << i_vsource.offset.kind() << std::endl;
  std::cout << "i_vsource.offset.name(): " << i_vsource.offset.name() << std::endl;
  std::cout << "default value of offset: " << i_vsource.offset << std::endl;

  std::cout << "i_vsource.amplitude.kind(): " << i_vsource.amplitude.kind() << std::endl;
  std::cout << "i_vsource.amplitude.name(): " << i_vsource.amplitude.name() << std::endl;
  std::cout << "default value of amplitude: " << i_vsource.amplitude << std::endl;

  std::cout << "i_vsource.frequency.kind(): " << i_vsource.frequency.kind() << std::endl;
  std::cout << "i_vsource.frequency.name(): " << i_vsource.frequency.name() << std::endl;
  std::cout << "default value of frequency: " << i_vsource.frequency << std::endl;

  std::cout << "i_vsource.phase.kind(): " << i_vsource.phase.kind() << std::endl;
  std::cout << "i_vsource.phase.name(): " << i_vsource.phase.name() << std::endl;
  std::cout << "default value of phase: " << i_vsource.phase << std::endl;

  std::cout << "i_vsource.delay.kind(): " << i_vsource.delay.kind() << std::endl;
  std::cout << "i_vsource.delay.name(): " << i_vsource.delay.name() << std::endl;
  std::cout << "default value of delay: " << i_vsource.delay << std::endl;

  std::cout << "i_vsource.ac_amplitude.kind(): " << i_vsource.ac_amplitude.kind() << std::endl;
  std::cout << "i_vsource.ac_amplitude.name(): " << i_vsource.ac_amplitude.name() << std::endl;
  std::cout << "default value of ac_amplitude: " << i_vsource.ac_amplitude << std::endl;

  std::cout << "i_vsource.ac_phase.kind(): " << i_vsource.ac_phase.kind() << std::endl;
  std::cout << "i_vsource.ac_phase.name(): " << i_vsource.ac_phase.name() << std::endl;
  std::cout << "default value of ac_phase: " << i_vsource.ac_phase << std::endl;

  std::cout << "i_vsource.ac_noise_amplitude.kind(): " << i_vsource.ac_noise_amplitude.kind() << std::endl;
  std::cout << "i_vsource.ac_noise_amplitude.name(): " << i_vsource.ac_noise_amplitude.name() << std::endl;
  std::cout << "default value of ac_noise_amplitude: " << i_vsource.ac_noise_amplitude << std::endl;

  TEST_LABEL_END;

  return 0;
}
